## xmds2 2.2.0+dfsg1

=== documentation/latex/Makefile ===
# Makefile for Sphinx LaTeX output

ALLDOCS = $(basename $(wildcard *.tex))
ALLPDF = $(addsuffix .pdf,$(ALLDOCS))
ALLDVI = $(addsuffix .dvi,$(ALLDOCS))

# Prefix for archive names
ARCHIVEPRREFIX =
# Additional LaTeX options
LATEXOPTS =

all: $(ALLPDF)
all-pdf: $(ALLPDF)
all-dvi: $(ALLDVI)
all-ps: all-dvi
	for f in *.dvi; do dvips $$f; done

all-pdf-ja:
	for f in *.pdf *.png *.gif *.jpg *.jpeg; do ebb $$f; done
	for f in *.tex; do platex -kanji=utf8 $(LATEXOPTS) $$f; done
	for f in *.tex; do platex -kanji=utf8 $(LATEXOPTS) $$f; done
	for f in *.tex; do platex -kanji=utf8 $(LATEXOPTS) $$f; done
	for f in *.idx; do mendex -U -f -d "`basename $$f .idx`.dic" -s python.ist $$f; done
	for f in *.tex; do platex -kanji=utf8 $(LATEXOPTS) $$f; done
	for f in *.tex; do platex -kanji=utf8 $(LATEXOPTS) $$f; done
	for f in *.dvi; do dvipdfmx $$f; done

zip: all-$(FMT)
	mkdir $(ARCHIVEPREFIX)docs-$(FMT)
	cp $(ALLPDF) $(ARCHIVEPREFIX)docs-$(FMT)
	zip -q -r -9 $(ARCHIVEPREFIX)docs-$(FMT).zip $(ARCHIVEPREFIX)docs-$(FMT)
	rm -r $(ARCHIVEPREFIX)docs-$(FMT)

tar: all-$(FMT)
	mkdir $(ARCHIVEPREFIX)docs-$(FMT)
	cp $(ALLPDF) $(ARCHIVEPREFIX)docs-$(FMT)
	tar cf $(ARCHIVEPREFIX)docs-$(FMT).tar $(ARCHIVEPREFIX)docs-$(FMT)
	rm -r $(ARCHIVEPREFIX)docs-$(FMT)

bz2: tar
	bzip2 -9 -k $(ARCHIVEPREFIX)docs-$(FMT).tar

# The number of LaTeX runs is quite conservative, but I don't expect it
# to get run often, so the little extra time won't hurt.
%.dvi: %.tex
	latex $(LATEXOPTS) '$<'
	latex $(LATEXOPTS) '$<'
	latex $(LATEXOPTS) '$<'
	-makeindex -s python.ist '$(basename $<).idx'
	latex $(LATEXOPTS) '$<'
	latex $(LATEXOPTS) '$<'

%.pdf: %.tex
	pdflatex $(LATEXOPTS) '$<'
	pdflatex $(LATEXOPTS) '$<'
	pdflatex $(LATEXOPTS) '$<'
	-makeindex -s python.ist '$(basename $<).idx'
	pdflatex $(LATEXOPTS) '$<'
	pdflatex $(LATEXOPTS) '$<'

clean:
	rm -f *.dvi *.log *.ind *.aux *.toc *.syn *.idx *.out *.ilg *.pla

.PHONY: all all-pdf all-dvi all-ps clean
.PHONY: all-pdf-ja

=== xpdeint/support/wscript ===
#!/usr/bin/env python
# encoding: utf-8
"""
wscript

The waf script to configure compilation of generated simulations.

Created by Graham Dennis on 2009-03-01.

Copyright (c) 2009-2012, Graham Dennis

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import os, sys, platform

from waflib import Task, TaskGen
from waflib.TaskGen import feature

def options(opt):
    # options provided by modules
    opt.load('compiler_cxx')

def optionAsList(var):
    if isinstance(var, str):
        return [var]
    elif isinstance(var, list):
        return var
    assert False


# This doesn't have great performance, but it's a small dataset we'll be working on
def append_to_unordered_set(dest, value):
    if value in dest:
        dest.remove(value)
    dest.append(value)

def expand_dependencies(dest, uselib, env):
    append_to_unordered_set(dest, uselib)
    if not uselib in env.uselib_dependencies: return
    expand_dependencies_of_list(dest, env.uselib_dependencies[uselib], env)

def expand_dependencies_of_list(dest, uselibs, env):
    for uselib in uselibs[:]:
        expand_dependencies(dest, uselib, env)


def configure(conf):
    env = conf.env
    
    env.uselib_dependencies = {}
    
    def _check_cxx(**KWs):
        # Don't execute when cross-compiling
        KWs['execute'] = not conf.env['is_cross_compile']
        KWs['mandatory'] = False
        KWs['ENVIRONMENT_NAME'] = conf.env['ENVIRONMENT_NAME']
        
        if 'cxxflags' in KWs:
          cxxflags = optionAsList(KWs['cxxflags'])
          
          linkflags = []
          if 'linkflags' in KWs:
            linkflags.extend(optionAsList(KWs['linkflags']))
          KWs['linkflags'] = linkflags
        
        original_uselib = []

        if 'uselib' in KWs:
            current_uselib = optionAsList(KWs['uselib'])
            original_uselib = current_uselib[:]
            expand_dependencies_of_list(current_uselib, original_uselib[:], conf.env)
            KWs['uselib'] = current_uselib
        
        result = conf.check_cxx(**KWs) not in [None, False]
        if result and 'uselib_store' in KWs:
            conf.env.append_unique('uselib', KWs['uselib_store'])
            if original_uselib:
                current_uselib_dep = conf.env.uselib_dependencies.setdefault(KWs['uselib_store'], [])
                for uselib in original_uselib:
                    if uselib == KWs['uselib_store']: continue
                    append_to_unordered_set(current_uselib_dep, uselib)
        return result
    
    def try_options(uselib_store, kwOptions, common = None):
        common = common or {}
        for kws in kwOptions:
            predicate = kws.get('predicate', True)
            if callable(predicate):
              predicate = predicate()
            if not predicate: continue
            
            allKWs = common.copy()
            allKWs.update(kws)
            if check_cxx(uselib_store=uselib_store, **allKWs):
                return True
        return False
    
    def check_cxx(**KWs):
        # Prefer a static library over a dynamic one if available
        if ('lib' not in KWs) or ('uselib_store' not in KWs) or ('_skip' in KWs):
            return _check_cxx(**KWs)
        
        lib = KWs['lib']
        del KWs['lib']
        uselib_store = KWs['uselib_store']
        KWs['_skip'] = True
        del KWs['uselib_store']
        options = [
            {'stlib': lib,   'msg': "%s (static library)" % KWs['msg'], 'errmsg': "no (will try dynamic library instead)"},
            {'lib'  : lib,   'msg': "%s (dynamic library)" % KWs['msg']},
        ]
        if not conf.env['STLIB_MARKER']:
            options = [
            # On systems like Mac OS X, it seems we can't force the linker to prefer static libraries over dynamic ones
            # Except of course by including them by listing the full path.
                {'lib': lib}
            ]
        if not 'errmsg' in KWs:
            KWs['errmsg'] = "no (it's optional anyway)"
            
        return try_options(uselib_store, options, KWs)
    
    
    def configure_compiler():
        conf.load('compiler_cxx')
        
        conf.check_cxx(
            msg = "Checking whether the compiler works",
            errmsg = "The compiler doesn't seem to work"
        )
        
        conf.check_cxx(
            msg = "Checking that we have a C++ compiler",
            fragment = """
            #include <iostream>
            int main() { return 0; }
            """,
            errmsg = "Please specify a C++ compiler."
        )

        conf.env['is_cross_compile'] = not conf.check_cxx(
            msg = "Checking whether we are cross-compiling",
            okmsg = "no",
            errmsg = "maybe, assuming we are",
            execute = True,
            mandatory = False,
        )
        
        # If we have a static library marker, try to link the simulation statically for performance.
        if conf.env['STLIB_MARKER']:
            conf.env['FINAL_LINK_VAR'] = conf.env['STLIB_MARKER']
            result = conf.check_cxx(
                msg = "Checking whether we can link to only static libraries",
                errmsg = "no (will use dynamic libraries)",
                mandatory = False,
                execute = not conf.env['is_cross_compile']
            )
            if not result:
                del conf.env['FINAL_LINK_VAR']
        
        
        if conf.env['CXX_NAME'] == 'gcc':
            machine_optimisations = [
                {
                    "msg": "Trying to make compiler optimise for this machine",
                    "cxxflags": "-march=native",
                },
                {
                    "msg": "Checking for Altivec",
                    "cxxflags": ['-mpim-altivec', '-maltivec'],
                },
                {
                    "msg": "Checking for AVX",
                    "cxxflags": ["-mavx", "-msse3", "-msse2", "-msse", "-mfpmath=sse"],
                },
                {
                    "msg": "Checking for SSE3",
                    "cxxflags": ["-msse3", "-msse2", "-msse", "-mfpmath=sse"],
                },
                {
                    "msg": "Checking for SSE2",
                    "cxxflags": ["-msse2", "-msse", "-mfpmath=sse"],
                },
                {
                    "msg": "Checking for SSE",
                    "cxxflags": ["-msse", "-mfpmath=sse"]
                }
            ]
            
            try_options('optimise', machine_optimisations,
                { # This is so that the compiler will generate SIMD instructions
                  # If the linker / assembler doesn't support those instructions,
                  # Then we'll pick it up this way.
                    "fragment": "int main() { double __volatile__ a = 1.0; a *= 1.03; return 0; }"
                }
            )
            
            check_cxx(
                cxxflags='-mtune=native',
                uselib_store="optimise",
                msg = "Trying to make compiler tune for this machine"
            )
            
            optimisation_flags = [
                '-O3', '-ffast-math', '-funroll-all-loops', '-fomit-frame-pointer', '-falign-loops', '-fstrict-aliasing', '-momit-leaf-frame-pointer'
            ]
            
            for optimisation_flag in optimisation_flags:
                check_cxx(
                    cxxflags=optimisation_flag,
                    uselib_store="optimise"
                )
            
            check_cxx(
                cxxflags=['-fno-unsafe-math-optimizations', '-fno-finite-math-only'],
                uselib_store="safe_math",
                uselib='optimise',
                msg = "Checking for cautious math flags"
            )
            
            if sys.platform == 'darwin':
                env.append_unique('CXXFLAGS', ['-mmacosx-version-min=%s' % '.'.join(platform.mac_ver()[0].split('.')[:2])])
            
            check_cxx(
                cxxflags='-ftree-vectorize',
                uselib_store='vectorise',
                uselib="optimise",
                msg = "Checking for Autovectorisation"
            )
            
            check_cxx(
                cxxflags='-fopenmp',
                linkflags="-fopenmp",
                uselib_store='openmp',
                msg = "Checking for OpenMP"
            )
            
            check_cxx(
                cxxflags="-pthread",
                linkflags="-pthread",
                uselib_store="threads",
                msg = "Checking for pthreads",
            )
        elif conf.env['CXX_NAME'] == 'icc':
            compiler_optimisations = [
                {
                    "msg": "Checking for the 'go fast' compiler option",
                    "cxxflags": ['-fast', '-ffast-math', '-complex-limited-range', '-fomit-frame-pointer'],
                    "linkflags": ["-fast"],
                },
                {
                    "msg": "Checking for fallback optimisation flags",
                    "cxxflags": ['-O3', '-ipo', '-ffast-math', '-complex-limited-range', '-fomit-frame-pointer'],
                    "linkflags": ['-O3'],
                },
                {
                    "msg": "Checking safe optimisation flags",
                    "cxxflags": "-O3",
                    "linkflags": "-O3"
                }
            ]
            
            try_options('optimise', compiler_optimisations)
            
            machine_optimisations = [
                {
                    "msg": "Trying to optimise for SSE4",
                    "cxxflags": "-xS",
                },
                {
                    "msg": "Trying to optimise for SSSE3",
                    "cxxflags": "-xT",
                },
                {
                    "msg": "Trying to optimise for SSE3",
                    "cxxflags": "-xP",
                },
                {
                    "msg": "Trying to optimise for SSE2",
                    "cxxflags": "-xN",
                },
            ]
            
            try_options('optimise', machine_optimisations)
            
            check_cxx(
                cxxflags="-fma",
                uselib_store="optimise",
                msg = "Trying to fuse multiply and add instructions"
            )
            
            check_cxx(
                cxxflags = ["-fp-model", "precise"],
                uselib_store="safe_math",
                uselib="optimise",
                msg = "Checking for cautious math flags"
            )
            
            check_cxx(
                cxxflags = "-vec",
                uselib_store="vectorise",
                uselib="optimise",
                msg = "Checking for Autovectorisation"
            )
            
            check_cxx(
                cxxflags='-openmp',
                linkflags="-openmp",
                uselib_store="openmp",
                msg = "Checking for OpenMP"
            )
            
            check_cxx(
                cxxflags="-pthread",
                linkflags="-pthread",
                uselib_store="threads",
                msg = "Checking for pthreads"
            )
        
        
        check_cxx(
            cxxflags="-g",
            uselib_store="debug",
            msg = "Checking for compiler debug flags"
        )

## xmds2 2.2.0%2Bdfsg1

=== debian/control ===
Source: xmds2
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Rafael Laboissiere <rafael@laboissiere.net>
Build-Depends: debhelper (>= 9),
               libfftw3-dev,
               libfftw3-mpi-dev,
               libgsl0-dev,
               libhdf5-serial-dev,
               libatlas-base-dev,
               mpi-default-bin,
               mpi-default-dev,
               octave,
               python,
               python-h5py,
               python-setuptools,
               python-pyparsing,
               python-mpmath,
               python-numpy,
               python-lxml,
               python-cheetah,
               xauth,
               xvfb
Standards-Version: 3.9.5
X-Python-Version: >= 2.4, << 3
Homepage: http://xmds.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/xmds2.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/xmds2.git

Package: xmds2
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
         libfftw3-dev,
         libfftw3-mpi-dev,
         libgsl0-dev,
         libhdf5-serial-dev,
         libatlas-base-dev,
         mpi-default-bin,
         mpi-default-dev,
         python-h5py,
         python-numpy,
         python-lxml,
         g++
Description: eXtensible Multi-Dimensional Simulator
 XMDS is a code generator that integrates equations, from Ordinary
 Differential Equations (ODEs) up to stochastic Partial Differential
 Equations (PDEs). You write them down in human readable form in an
 XML file, and it goes away and writes and compiles a C++ program that
 integrates those equations as fast as it can possibly be done in your
 architecture.
 .
 XMDS 2 is a major upgrade rewritten in Python which is faster and far
 more versatile than previous versions, allowing the efficient integration
 of almost any initial value problem on regular domains.

Package: xmds2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: documentation for the eXtensible Multi-Dimensional Simulator
 XMDS is a code generator that integrates equations, from Ordinary
 Differential Equations (ODEs) up to stochastic Partial Differential
 Equations (PDEs). You write them down in human readable form in an
 XML file, and it goes away and writes and compiles a C++ program that
 integrates those equations as fast as it can possibly be done in your
 architecture.
 .
 XMDS 2 is a major upgrade rewritten in Python which is faster and far
 more versatile than previous versions, allowing the efficient integration
 of almost any initial value problem on regular domains.
 .
 This package contains the documentation in HTML and PDF formats.

## xmds2 2.2.0+dfsg1

=== debian/changelog ===
xmds2 (2.2.0+dfsg1-3) unstable; urgency=medium

  * Support hdf5 1.8.13 new packaging layout.
    Thanks to Gilles Filippini for the patch (Closes: 756702)

 -- Rafael Laboissiere <rafael@laboissiere.net>  Sat, 02 Aug 2014 10:17:24 +0200

xmds2 (2.2.0+dfsg1-2) unstable; urgency=medium

  * Team upload.

  [ Rafael Laboissiere ]
  * debian/source/options: Add diff-ignore options for dpkg-source
  * Install only *.xmds files in the example directory
  * Add dependency on python-pkg-resources
  * Override Lintian errors on missing sources for some *.js files
  * Do not use Xvfb to run the lorenz example with Octave

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 09 Apr 2014 20:04:29 +0200

xmds2 (2.2.0+dfsg1-1) unstable; urgency=medium

  * Team upload.

  [ Rafael Laboissiere ]
  * Imported Upstream version 2.2.0+dfsg1
    In this new tarball, the automatically built file
    VectorInitialisationFromXSIL.py is removed, because it contains
    DFGS-incompatible code.
  * debian/copyright: Include the above file in the Files-Excluded list

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 02 Feb 2014 09:14:27 +0100

xmds2 (2.2.0+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Rafael Laboissiere ]
  * Imported Upstream version 2.2.0+dfsg
  * Make the package DFSG-compliant (Closes: #736413):
    + debian/copyright Drop non-GFDL documentation files from the tarball
    + The tarball is now repacked (hence the "+dfsg" suffix in the upstream
      version number)
    + debian/watch: Change uscan rule accordingly, for mangling the
     "+dfsg" suffix in the upstream tarball name
    + debian/patches/remove-non-dfsg-code.patch: New patch for removing
      non-dfsg code in VectorInitialisationFromXSIL.tmpl
    + debian/copyright: Specify the licenses of files in
      documentation/_static
  * Also, drop from the upstream tarball the *.jar and *.pyc files, which
    are automatically built (Lintian warning)

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 30 Jan 2014 23:09:43 +0100

xmds2 (2.2.0-1) unstable; urgency=medium

  * Team upload.

  [ Rafael Laboissiere ]
  * debian/patches/revision-number-as-deb-pkg.patch: New patch.
    This patch inserts the Debian package number in the notice shown by
    xmds2 and xsil2graphics2 at launching.
  * Imported Upstream version 2.2.0
  * Drop patches (applied upstream):
    + interpreter-name-in-shebang.patch
    + operator-bashism.patch
    + drop-dependency-on-sphinx.patch
    + string-quote-in-run-tests.patch
  * Add package xmds2-doc, with HTML and PDF forms of user documentation
  * debian/copyright: Reflect upstream changes
  * Drop dependencies on Cheetah, pyparsing and mpmath (guessed by dh_python2)
  * Drop useless dependency on python-setuptools
  * Use the appropriate version range in X-Python-Version
  * debian/patches/parse-dep-relationship.patch: New patch

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 15 Jan 2014 20:41:10 +0100

xmds2 (2.1.4-1) unstable; urgency=low

  [ Rafael Laboissiere ]
  * Initial version for Debian (Closes: #597014, #734262)
  * debian/source/format: 3.0 (quilt)
  * debian/control:
    + Add mandatory build-dependency on python
    + Declare package to be architecture-independent
    + Drop unused build-dependency on cdbs
    + Drop useless dependencies on python-markdown
    + Drop ${shlibs:Depends} (this is an arch:all package)
    + Bump Standards-Version to 3.9.5
    + Declare the Debian Science Team as the maintainer
    + Use XS-Python-Version instead of deprecated XB-Python-Version
    + Drop duplicated dependency on python-pyparsing
    + Set Section to "science" and Priority to "extra"
    + Add Vcs-{Git,Browser} fields
    + Add paragraph to the Description field about the differences to xmds v1
    + Add dependency to libfftw3-mpi-dev and libgsl0-dev
    + Replace dependencies on mpich2 by mpi-default-{dev,bin}
    + Build-depend on all run-time dependencies, such that the unit test
      suite works
    + Add my name to the list of Uploaders
  * debian/rules: 
    + Remove the build directory in the clean rule
    + Run the lorenz.xmds example as unit test
    + Run the unit test suite run_tests.py
  * debian/watch: Add file for uscan
  * Bump the debhelper compatibility level to 9
  * debian/copyright:
    + DEP-5-compliant
    + Add licenses for third-party software (waf, dSFMT, and Solirte)
  * debian/docs: Drop the COPYRIGHT file (redundant with debian/copyright)
  * New patch interpreter-name-in-shebang.patch
  * New patch operator-bashism.patch
  * New patch drop-dependency-on-sphinx.patch
  * New patch string-quote-in-run-tests.patch

  [ Andreas Tille ]
  * debian/control: Priority: optional
  * cme fix dpkg-copyright

 -- Rafael Laboissiere <rafael@laboissiere.net>  Wed, 08 Jan 2014 10:17:41 +0100

xmds2 (2.1.2-1-20121121) wheezy-evmik; urgency=low

  * Debianization

 -- Eugeniy Mikhailov <evgmik@gmail.com>  Wed, 21 Nov 2012 15:11:20 -0500

=== debian/control ===
--- 
+++ 
@@ -19,9 +19,7 @@
                python-mpmath,
                python-numpy,
                python-lxml,
-               python-cheetah,
-               xauth,
-               xvfb
+               python-cheetah
 Standards-Version: 3.9.5
 X-Python-Version: >= 2.4, << 3
 Homepage: http://xmds.sourceforge.net/
@@ -42,6 +40,7 @@
          python-h5py,
          python-numpy,
          python-lxml,
+         python-pkg-resources,
          g++
 Description: eXtensible Multi-Dimensional Simulator
  XMDS is a code generator that integrates equations, from Ordinary

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

XMDS_USER_DATA = $(CURDIR)/debian/xmds-user-data

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
	HDF5_PATHS := --include-path=/usr/include/hdf5/serial \
		--lib-path=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

#DH_VERBOSE=1

%:
	dh $@ --with python2

override_dh_auto_install:
	python setup.py install --root=debian/xmds2 --install-layout=deb 

override_dh_auto_test:
	( export PYTHONPATH=$$(pwd) ;			\
	  export PATH=$$(pwd)/bin-test:$$PATH ;		\
	  export XMDS_USER_DATA=$(XMDS_USER_DATA) ;	\
	  unset CXXFLAGS ; export CXXFLAGS ; 		\
          export OMPI_MCA_plm_rsh_agent=/bin/false ;	\
	  mkdir bin-test ;				\
	  install -m 755 bin/* bin-test ; 		\
	  xmds2 --reconfigure $(HDF5_PATHS) ;		\
	  ./run_tests.py ;				\
	  cd ./examples ;				\
	  xmds2 lorenz.xmds ;				\
	  ./lorenz | grep '^\(Seg\|  Att\|Gen\)' ;	\
	  xsil2graphics2 -m lorenz.xsil ;		\
	  echo "source ('lorenz.m');			\
		figure ('visible', 'off');		\
		plot (t_1, xR_1);			\
		disp ('Octave plot succeeded')"		\
		| octave -qf )

override_dh_auto_clean:
	dh_clean
	cd xpdeint; waf/waf-light configure
	make clean
	rm -rf xmds2.egg-info/
	rm -f xpdeint/.lock-waf_linux2_build
	rm -f xpdeint/.wafpickle-98
	rm -f xpdeint/Version.py
	rm -rf xpdeint/c4che/
	rm -f xpdeint/config.log
	rm -rf build/
	( cd examples ; rm -f lorenz.cc lorenz lorenz.xsil lorenz.h5 lorenz.m )
	rm -rf testsuite_results $(XMDS_USER_DATA) bin-test

## xmds2 2.2.2+dfsg

=== Makefile ===
SUBDIRS = xpdeint

.PHONY: all update clean check distclean

all:
	@for i in $(SUBDIRS); do \
	(cd $$i; $(MAKE) $(MFLAGS) all); done

update:
	@svn up
	@$(MAKE) $(MFLAGS) all

# remove all compiled files
clean:
	@for i in $(SUBDIRS); do \
	(cd $$i; $(MAKE) $(MFLAGS) clean); done

# check examples compile
check:
	@for i in $(SUBDIRS); do \
	(cd $$i; $(MAKE) $(MFLAGS) check); done

distclean:
	@for i in $(SUBDIRS); do \
	(cd $$i; $(MAKE) $(MFLAGS) distclean); done

=== xpdeint/support/wscript ===
--- 
+++ 
@@ -23,9 +23,9 @@
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 """
 
-import os, sys, platform
-
-from waflib import Task, TaskGen
+import os, sys, platform, re
+
+from waflib import Task, TaskGen, Errors
 from waflib.TaskGen import feature
 
 def options(opt):
@@ -117,15 +117,18 @@
         uselib_store = KWs['uselib_store']
         KWs['_skip'] = True
         del KWs['uselib_store']
+        extra_static_kws = KWs.get("static_lib_extra_options", {})
+        extra_shared_kws = KWs.get("shared_lib_extra_options", {})
+        
         options = [
-            {'stlib': lib,   'msg': "%s (static library)" % KWs['msg'], 'errmsg': "no (will try dynamic library instead)"},
-            {'lib'  : lib,   'msg': "%s (dynamic library)" % KWs['msg']},
+            dict(stlib=lib, msg=KWs['msg'] + " (static library)", errmsg="no (will try dynamic library instead)", **extra_static_kws),
+            dict(lib=lib,   msg=KWs['msg'] + " (dynamic library)", **extra_shared_kws),
         ]
         if not conf.env['STLIB_MARKER']:
             options = [
             # On systems like Mac OS X, it seems we can't force the linker to prefer static libraries over dynamic ones
             # Except of course by including them by listing the full path.
-                {'lib': lib}
+                dict(lib=lib, **extra_shared_kws),
             ]
         if not 'errmsg' in KWs:
             KWs['errmsg'] = "no (it's optional anyway)"
@@ -331,8 +334,3 @@
         
         
         check_cxx(
-            cxxflags="-g",
-            uselib_store="debug",
-            msg = "Checking for compiler debug flags"
-        )
-

=== debian/changelog ===
xmds2 (2.2.2+dfsg-2) unstable; urgency=medium

  * d/control:
    + Update to ligsl-dev in Build-Depends and Depends
    + Add dh-python and gnuplot-nox to Build-Depends

 -- Rafael Laboissiere <rafael@laboissiere.net>  Wed, 16 Dec 2015 10:36:26 +0100

xmds2 (2.2.2+dfsg-1) unstable; urgency=low

  * Imported Upstream version 2.2.2+dfsg
  * d/watch: Mangle RC part of upstream tarball name

 -- Rafael Laboissiere <rafael@laboissiere.net>  Tue, 14 Oct 2014 07:05:55 -0300

xmds2 (2.2.1+dfsg-1) unstable; urgency=low

  * Imported Upstream version 2.2.1+dfsg
  * Add python-mpmath and python-scipy to Suggests
  * Drop patch parse-dep-relationship.patch (fixed in python-minimal 2.7.8-1)
  * Drop patch remove-non-dfsg-code.patch (applied upstream)
  * Drop patch show-library-name.patch (applied upstream)
  * Drop patch wscript-hdf5.patch (applied upstream)

 -- Rafael Laboissiere <rafael@laboissiere.net>  Tue, 30 Sep 2014 22:06:15 -0300

xmds2 (2.2.0+dfsg1-4) unstable; urgency=low

  * Link against installed versions of files underscore.js and jquery.js.
    The xmds2-doc package now depends on libjs-jquery and
    libjs-underscore, complying with section 4.13 of the Debian Policy.
  * debian/patches/show-library-name.patch: New patch
  * Bump to Standards-Version 3.9.6, no changes needed
  * wscript-hdf5.patch: New patch for getting the correct flags for HDF5.
    Thanks to Gilles Filippini
  * d/copyright: Specify BSD licenses
  * Replace hyperlinks to Mathjax website by local ones in libjs-mathjax

 -- Rafael Laboissiere <rafael@laboissiere.net>  Sun, 21 Sep 2014 12:18:57 -0300

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,11 @@
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Rafael Laboissiere <rafael@laboissiere.net>
 Build-Depends: debhelper (>= 9),
+               dh-python,
+               gnuplot-nox,
                libfftw3-dev,
                libfftw3-mpi-dev,
-               libgsl0-dev,
+               libgsl-dev,
                libhdf5-serial-dev,
                libatlas-base-dev,
                mpi-default-bin,
@@ -20,7 +22,7 @@
                python-numpy,
                python-lxml,
                python-cheetah
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 X-Python-Version: >= 2.4, << 3
 Homepage: http://xmds.sourceforge.net/
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/xmds2.git
@@ -32,7 +34,7 @@
          ${misc:Depends},
          libfftw3-dev,
          libfftw3-mpi-dev,
-         libgsl0-dev,
+         libgsl-dev,
          libhdf5-serial-dev,
          libatlas-base-dev,
          mpi-default-bin,
@@ -42,6 +44,8 @@
          python-lxml,
          python-pkg-resources,
          g++
+Suggests: python-mpmath,
+          python-scipy
 Description: eXtensible Multi-Dimensional Simulator
  XMDS is a code generator that integrates equations, from Ordinary
  Differential Equations (ODEs) up to stochastic Partial Differential
@@ -57,7 +61,10 @@
 Package: xmds2-doc
 Architecture: all
 Section: doc
-Depends: ${misc:Depends}
+Depends: ${misc:Depends},
+         libjs-jquery,
+         libjs-underscore,
+         libjs-mathjax
 Description: documentation for the eXtensible Multi-Dimensional Simulator
  XMDS is a code generator that integrates equations, from Ordinary
  Differential Equations (ODEs) up to stochastic Partial Differential

=== debian/rules ===
--- 
+++ 
@@ -2,11 +2,6 @@
 # -*- makefile -*-
 
 XMDS_USER_DATA = $(CURDIR)/debian/xmds-user-data
-
-ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
-	HDF5_PATHS := --include-path=/usr/include/hdf5/serial \
-		--lib-path=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
-endif
 
 #DH_VERBOSE=1
 
@@ -24,7 +19,7 @@
           export OMPI_MCA_plm_rsh_agent=/bin/false ;	\
 	  mkdir bin-test ;				\
 	  install -m 755 bin/* bin-test ; 		\
-	  xmds2 --reconfigure $(HDF5_PATHS) ;		\
+	  xmds2 --reconfigure ;				\
 	  ./run_tests.py ;				\
 	  cd ./examples ;				\
 	  xmds2 lorenz.xmds ;				\
@@ -49,3 +44,17 @@
 	rm -rf build/
 	( cd examples ; rm -f lorenz.cc lorenz lorenz.xsil lorenz.h5 lorenz.m )
 	rm -rf testsuite_results $(XMDS_USER_DATA) bin-test
+
+JSDIR = /usr/share/javascript
+INSTDIR = $(CURDIR)/debian/xmds2-doc
+DOCDIR = $(INSTDIR)/usr/share/doc/xmds2-doc
+override_dh_installdocs:
+	dh_installdocs
+	# Fix Lintian error privacy-breach-may-use-debian-package
+	sed -i 's|http://cdn.mathjax.org/mathjax/latest/|file:///usr/share/javascript/mathjax/|g;s|http://www.xmds.org/|file:///usr/share/doc/xmds2-doc/|g' $(DOCDIR)/*.html $(DOCDIR)/_static/*.js
+	for i in underscore jquery ; do						\
+		ln -fs $(JSDIR)/$$i/$$i.js $$(find $(INSTDIR) -name $$i.js) ;	\
+	done
+
+get-orig-source:
+	uscan --verbose --force-download --repack --compression=xz

=== debian/watch ===
version=3
opts="uversionmangle=s/^xmds-/xmds2-/;s/-rc/~rc/,dversionmangle=s/[~+]dfsg[0-9]*//" \
  http://sf.net/xmds/xmds-(.*)\.tar\.gz

## xmds2 2.2.3%2Bdfsg

=== xpdeint/Makefile ===
.PHONY: all update clean check distclean

all: wscript waf_extensions/cheetah.py c4che
	@waf/waf-light build
	@sh version.sh

update:
	@(cd ..; $(MAKE) $(MFLAGS) update;)

c4che: wscript waf_extensions/cheetah.py
	@waf/waf-light configure

clean:
	@waf/waf-light clean

# check examples compile
check:
	@for i in examples/*.xmds; do \
	echo $$i; xmds2 $$i; done

distclean:
	@waf/waf-light distclean

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#DH_VERBOSE=1

%:
	dh $@ --with python2

override_dh_auto_install:
	python setup.py install --root=debian/xmds2 --install-layout=deb
	python debian/fix-cheetah-build-str.py

override_dh_auto_test:
	debian/tests/run-tests -b

override_dh_auto_clean:
	cd xpdeint; waf/waf-light configure
	make clean
	dh_clean

JSDIR = /usr/share/javascript
INSTDIR = $(CURDIR)/debian/xmds2-doc
DOCDIR = $(INSTDIR)/usr/share/doc/xmds2
override_dh_installdocs:
	dh_installdocs
	# Fix Lintian error privacy-breach-may-use-debian-package
	sed -i 's|http://cdn.mathjax.org/mathjax/latest/|file:///usr/share/javascript/mathjax/|g;s|http://www.xmds.org/|file:///usr/share/doc/xmds2/|g' $(DOCDIR)/*.html $(DOCDIR)/_static/*.js
	for i in underscore jquery ; do						\
		ln -fs $(JSDIR)/$$i/$$i.js $$(find $(INSTDIR) -name $$i.js) ;	\
	done

get-orig-source:
	uscan --verbose --force-download --repack --compression=xz

=== debian/tests/control ===
Tests: run-tests
Depends: xmds2, octave, gnuplot-nox
Restrictions: allow-stderr

## xmds2 2.2.3+dfsg

=== xpdeint/wscript ===
#!/usr/bin/env python
# encoding: utf-8
"""
wscript

The waf build script to compile all Cheetah templates.

Created by Graham Dennis on 2009-02-22.

Copyright (c) 2009-2012, Graham Dennis

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""

top = '.'
out = '.'

def options(opt):
    opt.load('cheetah', tooldir='waf_extensions')

def configure(conf):
    conf.load('cheetah', tooldir='waf_extensions')
    conf.env['CHEETAH_SETTINGS'] = {
            'directiveStartToken': '@',
            'commentStartToken': '@#',
            'multiLineCommentStartToken': '@*',
            'multiLineCommentEndToken': '*@',
        }

def build(bld):
    sources = bld.path.ant_glob('**/*.tmpl')
    if bld.cmd == 'clean':
        for n in sources:
            n.change_ext('.py').delete()
        for n in bld.path.ant_glob('**/*.pyc'):
            n.delete()
    else:
        bld(source=sources)

=== xpdeint/support/wscript ===
--- 
+++ 
@@ -229,7 +229,6 @@
             check_cxx(
                 cxxflags=['-fno-unsafe-math-optimizations', '-fno-finite-math-only'],
                 uselib_store="safe_math",
-                uselib='optimise',
                 msg = "Checking for cautious math flags"
             )
             
@@ -334,3 +333,4 @@
         
         
         check_cxx(
+            cxxflags="-g",

=== debian/changelog ===
xmds2 (2.2.3+dfsg-8) unstable; urgency=medium

  * Add versioned (automatically generated) dependency on python-cheetah

 -- Rafael Laboissiere <rafael@debian.org>  Wed, 20 Jun 2018 21:52:43 -0300

xmds2 (2.2.3+dfsg-7) unstable; urgency=medium

  * d/t/run-tests: Define OMPI_MCA_rmaps_base_oversubscribe.
    This variable was previously defined in d/rules and the setting was
    not taken into account by autokgtest at the Debian CI infrastructure.

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 06 May 2018 15:15:14 -0300

xmds2 (2.2.3+dfsg-6) unstable; urgency=medium

  * Migrate get-orig-source into debian/watch
  * d/control: Bump Standards-Version to 4.1.4
  * d/rules:
    + Oversubscribe nodes for MPI unit tests (Closes: 897501)
    + Honor DEB_BUILD_OPTIONS in target override_dh_auto_test

 -- Rafael Laboissiere <rafael@debian.org>  Fri, 04 May 2018 03:33:06 -0300

xmds2 (2.2.3+dfsg-5) unstable; urgency=medium

  * d/control: Build-depend on libhdf5-dev instead of transitional
    libhdf5-serial-dev (Closes: 879150)

 -- Rafael Laboissiere <rafael@debian.org>  Mon, 08 Jan 2018 18:07:16 -0200

xmds2 (2.2.3+dfsg-4) unstable; urgency=medium

  * Use debhelper compatibility level 11
  * d/xmds2-doc.doc-base: Use new (debhelper compat 11) paths for files
  * d/control:
    + Bump Standards-Version to 4.1.3 (no changes needed)
    + Use Debian's GitLab URLs in Vcs-* headers

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 28 Dec 2017 16:54:06 -0200

xmds2 (2.2.3+dfsg-3) unstable; urgency=medium

  * d/control: Use cgit URL in Vcs-Browser
  * d/u/metadata: Fix FAQ URL
  * d/control: Bump Standards-Version to 4.1.1 (no changes needed)
  * Add support for autopkgtest
  * d/clean: New file

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 07 Oct 2017 04:03:47 -0300

xmds2 (2.2.3+dfsg-2) unstable; urgency=medium

  * d/copyright: Use secure URL in Format
  * d/watch: Upgrade to version 4
  * d/control: Bump Standards-Version to 4.0.0 (no changes needed)
  * Ensure reproducible build
    + d/fix-cheetah-build-str.py: New script for replacing
      timestamp and build paths generated by Cheetah
    + d/control: Build-depends on python-debian and python-dateutil
    + d/rules: Call fix-cheetah-build-str.py in the
      override_dh_auto_install rule

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 29 Jun 2017 17:48:08 -0300

xmds2 (2.2.3+dfsg-1) unstable; urgency=medium

  * New upstream version 2.2.3+dfsg
  * d/copyright: Reflect upstream changes
  * Drop patch (applied upstream):
    + d/p/spelling-fix-in-manpage.patch
    + d/p/pyparsing-dict.patch
    + d/p/indexing-with-scalars.patch
  * d/s/lintian-overrides: Drop unused Lintian overrides
  * d/rules: Run unit tests in verbose mode

 -- Rafael Laboissiere <rafael@debian.org>  Fri, 03 Feb 2017 18:49:15 -0200

xmds2 (2.2.2+dfsg-3) unstable; urgency=medium

  * Bump debhelper compat level to 10
  * Bump Standards-Version to 3.9.8 (no changes needed)
  * d/watch: Avoid listing the xmds-doc tarballs
  * d/u/metadata: Add citation
  * d/s/lintian-overrides: Refresh for new Lintian behavior
  * d/control: Use secure URIs in VCS fields
  * d/p/spelling-fix-in-manpage.patch: New patch
  * d/p/pyparsing-dict.patch: New patch
  * d/p/indexing-with-scalars.patch: New patch

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 15 Jan 2017 18:05:09 -0200

=== debian/control ===
--- 
+++ 
@@ -2,19 +2,21 @@
 Section: science
 Priority: optional
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Rafael Laboissiere <rafael@laboissiere.net>
-Build-Depends: debhelper (>= 9),
+Uploaders: Rafael Laboissiere <rafael@debian.org>
+Build-Depends: debhelper (>= 11),
                dh-python,
                gnuplot-nox,
                libfftw3-dev,
                libfftw3-mpi-dev,
                libgsl-dev,
-               libhdf5-serial-dev,
+               libhdf5-dev,
                libatlas-base-dev,
                mpi-default-bin,
                mpi-default-dev,
                octave,
                python,
+               python-dateutil,
+               python-debian,
                python-h5py,
                python-setuptools,
                python-pyparsing,
@@ -22,11 +24,11 @@
                python-numpy,
                python-lxml,
                python-cheetah
-Standards-Version: 3.9.6
+Standards-Version: 4.1.4
 X-Python-Version: >= 2.4, << 3
 Homepage: http://xmds.sourceforge.net/
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/xmds2.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/xmds2.git
+Vcs-Git: https://salsa.debian.org/science-team/xmds2.git
+Vcs-Browser: https://salsa.debian.org/science-team/xmds2
 
 Package: xmds2
 Architecture: all
@@ -39,6 +41,7 @@
          libatlas-base-dev,
          mpi-default-bin,
          mpi-default-dev,
+         python-cheetah (>= ${Cheetah-Version}),
          python-h5py,
          python-numpy,
          python-lxml,

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,9 @@
 	python debian/fix-cheetah-build-str.py
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	debian/tests/run-tests -b
+endif
 
 override_dh_auto_clean:
 	cd xpdeint; waf/waf-light configure
@@ -29,5 +31,5 @@
 		ln -fs $(JSDIR)/$$i/$$i.js $$(find $(INSTDIR) -name $$i.js) ;	\
 	done
 
-get-orig-source:
-	uscan --verbose --force-download --repack --compression=xz
+override_dh_gencontrol:
+	dh_gencontrol -- -VCheetah-Version="$(shell dpkg -s python-cheetah | grep ^Version: | cut -f2 -d\ )"

## xmds2 3.0.0%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#DH_VERBOSE=1

ifeq ($(dpkg-architecture -qDEB_BUILD_ARCH),ppc64el)
DEB_BUILD_MAINT_OPTIONS = nocheck
endif

%:
	dh $@ --with python3

override_dh_auto_install:
	python3 setup.py install --root=debian/xmds2 --install-layout=deb
	python3 debian/fix-cheetah-build-str.py

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	debian/tests/run-tests -b
endif

override_dh_auto_clean:
	cd xpdeint; waf/waf-light configure
	make clean
	dh_clean

JSDIR = /usr/share/javascript
INSTDIR = $(CURDIR)/debian/xmds2-doc
DOCDIR = $(INSTDIR)/usr/share/doc/xmds2
execute_after_dh_installdocs:
	# Fix Lintian error privacy-breach-may-use-debian-package
	sed -i 's|http://cdn.mathjax.org/mathjax/latest/|file:///usr/share/javascript/mathjax/|g;s|http://www.xmds.org/|file:///usr/share/doc/xmds2/|g' $(DOCDIR)/*.html $(DOCDIR)/_static/*.js
	# Symlink against the system-intalled JS libraries
	ln -fs $$(find $(JSDIR)/underscore -name underscore.js) $$(find $(INSTDIR) -name underscore.js)
	ln -fs $$(find -L $(JSDIR)/jquery -name jquery.js) $$(find $(INSTDIR) -name jquery.js)
	ln -fs $$(find $(JSDIR)/sphinxdoc -name doctools.js) $$(find $(INSTDIR) -name doctools.js)
	ln -fs $$(find $(JSDIR)/sphinxdoc -name searchtools.js) $$(find $(INSTDIR) -name searchtools.js)

CHEETAH_MAJOR_VERSION = $(shell dpkg -s python3-cheetah | grep ^Version: | cut -f2 -d\  | cut -f1 -d.)
override_dh_gencontrol:
	dh_gencontrol -- -VCheetah-Depends="python3-cheetah (>= $(CHEETAH_MAJOR_VERSION)), python3-cheetah (<< $$(($(CHEETAH_MAJOR_VERSION) + 1)))"

execute_before_dh_installdeb:
	# Remove pre-compiled Python source files, as per the Debian
	# Python Policy section 3.7 (Modules Byte-Compilation)
	@echo "*********************************************************"
	@echo "Warning: check whether the following fix is still needed:"
	@echo "*********************************************************"
	find debian/xmds2 -name __pycache__ -exec rm -r '{}' \;
	# Make wscript non executable
	@echo "*********************************************************"
	@echo "Warning: check whether the following fix is still needed:"
	@echo "*********************************************************"
	find debian/xmds2 -name wscript -exec chmod -x '{}' \;
